﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraMessageBox;


namespace WindowsFormsApplication1
{
    public partial class ResultMasterControl : System.Windows.Forms.UserControl, INotifyPropertyChanged
    {
        #region Members

        private String _result;                
        private PropertyChangedEventHandler _propertyChangedDelegate;

        #endregion

        #region Properties

        public String Result
        {
            get { return _result; }
            set 
            {
                PropertyChanged -= new PropertyChangedEventHandler(result_PropertyChanged);         
                _result = value;
                updateUI();
                PropertyChanged += new PropertyChangedEventHandler(result_PropertyChanged);
            }
        }
        public Boolean Updated { get; set; }        

        #endregion

        #region Events

        //public event EventHandler BeforeExitEditMode = null; 

        #endregion

        #region ctor

        public ResultMasterControl()
        {
            InitializeComponent();

            answerUltraTextEditor.MaxLength = 10;
            answerUltraTextEditor.Appearance.TextTrimming = Infragistics.Win.TextTrimming.EllipsisCharacter;

            SetStyle(ControlStyles.SupportsTransparentBackColor, true);
        } 

        #endregion               

        private void resetResult()
        {                        
            answerUltraTextEditor.ResetText();            
        }

        private void updateUI()
        {
            answerUltraTextEditor.TextChanged -= new EventHandler(answerUltraTextEditor_TextChanged);
            answerUltraTextEditor.Text = Result;
            answerUltraTextEditor.TextChanged += new EventHandler(answerUltraTextEditor_TextChanged);
        }


        private Boolean tabbingOut = false;
        private void answerUltraTextEditor_BeforeExitEditMode(object sender, Infragistics.Win.BeforeExitEditModeEventArgs e)
        {
            if (tabbingOut)
            {
                tabbingOut = false;
                e.Cancel = true;
            }
            tabbingOut = false;
            //if (e.IsForcingExit) return;
            //e.Cancel = !_isValid;            
        }                
        
        private void answerUltraTextEditor_TextChanged(object sender, EventArgs e)
        {            
            Result = answerUltraTextEditor.Text;
            Updated = true;            
        }
             
        private void result_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            updateUI();
        }


        #region INotifyPropertyChanged Membres

        public event PropertyChangedEventHandler PropertyChanged
        {
            add
            {
                if (_propertyChangedDelegate == null)
                    _propertyChangedDelegate = value;
                else
                    _propertyChangedDelegate = (PropertyChangedEventHandler)Delegate.Combine(_propertyChangedDelegate, value);
            }
            remove
            {
                if (_propertyChangedDelegate != null)
                    _propertyChangedDelegate = (PropertyChangedEventHandler)Delegate.Remove(_propertyChangedDelegate, value);
            }
        }

        #endregion

        private void answerUltraTextEditor_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Tab)
            {
                tabbingOut = true;
            }
            else
            {
                tabbingOut = false;
            }
        }
    }
}
